import 'dart:convert';

import 'package:http/http.dart';

import '../../controllers/api_routes/api_manager.dart';
import '../../controllers/api_routes/urls.dart';
import '../../models/lookup.dart';
import 'loading_list_notifier.dart';

class DepartmentProvider extends LoadingListNotifier<Lookup> {
  @override
  Future getDate() async {
    if (loading ?? false) return -2;
    loading = true;
    notifyListeners();
    try {
      Response response = await ApiManager.instance.get(URLs.getDepartments);
      stateCode = response.statusCode;
      if (response.statusCode >= 200 && response.statusCode < 300) {
        // client's request was successfully received
        List categoriesListJson = json.decode(response.body)["data"];
        items = categoriesListJson.map((item) => Lookup.fromJson(item)).toList();
      }
      loading = false;
      notifyListeners();
      return response.statusCode;
    } catch (error) {
      loading = false;
      stateCode = -1;
      notifyListeners();
      return -1;
    }
  }
}
